Description

When a OperatingSystem has:

- finish Template

- user-data Template

The finish is not processed, and no error in log.

History

#1 - 09/23/2016 08:19 AM - Dominic Cleal

- Category set to Compute resources - VMware

- Status changed from New to Feedback

This is normal behaviour - when user data is disabled, Foreman will SSH to the host to complete configuration and executes the finish template.

When user data is enabled, the user data template is rendered instead and provided to the hypervisor to complete initial configuration. They're

mutually exclusive.

#2 - 09/23/2016 08:25 AM - Fab Ien

Dominic Cleal wrote:

This is normal behaviour - when user data is disabled, Foreman will SSH to the host to complete configuration and executes the finish template.

When user data is enabled, the user data template is rendered instead and provided to the hypervisor to complete initial configuration. They're

mutually exclusive.

 In case of VMWare Image, the user-data is converted to "OS Guest Customization format" which only contains network/dns/hostname configuration.

So i can not notify TheForeman to tell him, the VM is installed ?

(i also need to execute some bootstrap script).

And can not execute "wget -q -O /dev/null --no-check-certificate <%= foreman_url %>" on the Host.

It would be good to process the Finish (via SSH).

#3 - 09/23/2016 08:30 AM - Dominic Cleal

- Tracker changed from Bug to Feature

- Subject changed from VMWare image: finish not processed when user-data is set to Support dual user data and SSH finish script provisioning

- Category changed from Compute resources - VMware to Compute resources

- Status changed from Feedback to New

Consider putting a script in the image instead, Foreman will not SSH to the host. The script may even retrieve the assigned finish script from

/unattended/finish.

#4 - 09/23/2016 10:14 AM - Fab Ien

ok but it would be more consistent with to execute both user-data and finish.
As "VMWare user-data" is not as flexible as "EC2 user-data"

#5 - 02/24/2017 02:17 PM - Matt Arva

Fab Ien wrote:

ok but it would be more consistent with to execute both user-data and finish.

As "VMWare user-data" is not as flexible as "EC2 user-data"

 I agree that if a user-data template is used as a "OS Guest Customization format" for VMware template provisioning, that a finishing template would

be beneficial for completing additional customization, like registering the host in Foreman (subscription-manager w/ activation keys linked to a

particular content-view), installing the katello-agent and puppet, etc).   Currently, when I create a host using user-data template (OS Guest

Customization), the VM deployment completes, the host networking is modified and is accessible on the network.  At this point the status of the host

build is "Pending Installation" and no other activities occur.
